当我在解决leetcode上的问题时,它说在给定的按非递减顺序排序的整数nums数组中,找到给定目标值的开始和结束位置。因此不可能用简单的二进制 Sarch 来返回数组中目标元素的开始和结束,因为它只返回找到第一个目标元素的索引,该元素可以是该元素的第一个、结尾或中间的任何内容。所以我们使用 Double Binary Scarch ,这是如何做到的...
第一次二分查找:
第二次二分查找:
返回结果:
时间复杂度:
空间复杂度:
class Solution { public int[] searchRange(int[] nums, int target) { int ei = nums.length - 1; int si = 0; int[] res = {-1, -1}; // Initialize result array // First binary search to find the last occurrence while (si nums[mid]) { si = mid 1; } else { res[1] = mid; // Update end index si = mid 1; // Search in the right half } } // Reset the pointers for the second binary search si = 0; ei = nums.length - 1; // Second binary search to find the first occurrence while (si nums[mid]) { si = mid 1; } else { res[0] = mid; // Update start index ei = mid - 1; // Search in the left half } } return res; // Return the result array } }
免责声明: 提供的所有资源部分来自互联网,如果有侵犯您的版权或其他权益,请说明详细缘由并提供版权或权益证明然后发到邮箱:[email protected] 我们会第一时间内为您处理。
Copyright© 2022 湘ICP备2022001581号-3